package cli

import (
	"errors"
	"os/exec"

	xerrors "git.akyoto.dev/cli/q/src/errors"
)

// exit returns the exit code depending on the error type.
func exit(err error) int {
	var (
		exit              *exec.ExitError
		expectedParameter *xerrors.ExpectedCLIParameter
		unknownParameter  *xerrors.UnknownCLIParameter
	)

	if errors.As(err, &exit) {
		return exit.ExitCode()
	}

	if errors.As(err, &expectedParameter) || errors.As(err, &unknownParameter) {
		return 2
	}

	return 1
}
